package fr.itsonus.bousoleplussbackend.repositories;

import fr.itsonus.bousoleplussbackend.models.Axe;
import fr.itsonus.bousoleplussbackend.projections.AxeWithQuestion;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.rest.core.annotation.RepositoryRestResource;
import org.springframework.data.rest.core.annotation.RestResource;

@RepositoryRestResource(excerptProjection = AxeWithQuestion.class)
public interface AxeRepository extends CrudRepository<Axe, Long> {

    @RestResource(path = "me", rel = "me")
    @Query("SELECT DISTINCT a FROM Axe a INNER JOIN a.questions as q WHERE q.userId = ?#{principal.id}")
    Iterable<Axe> findAllWithQuestionsOfCurrentUser();
}
